import 'dart:convert';
import 'dart:developer';

import 'package:http/http.dart' as http;

void main() async {
  var uname = '0a937f5bd8d0ab46753dd22b';
  var pword = 'fa32f47740be012a4b9896a2';
  var authn = 'Basic ' + base64Encode(utf8.encode('$uname:$pword'));

  var headers = {
    'Content-Type': 'application/json',
    'Authorization': authn,
  };

  var data = """
{"platform":["ios","android"],"options":{"apns_production":true,"third_party_channel":{"huawei":{"distribution":"secondary_push",importance":"NORMAL","channel_id": "jh_push"}}},"audience":{"registration_id":["120c83f760fb60c6375","121c83f760e3b2fcdb3","101d855909922ad5ce8"]},"notification":{"android":{"alert":"您有一个新的美团外卖#17订单已经被小店掌柜自动接单啦！","extras":{"voice_num":3,"voice_code":"2_0102_131","voice_text":"美团外卖自动接单，刚刚为您接到新订单哦，请尽快处理"},"title":"美团外卖-t_abQZElFv #17 小店掌柜自动接单通知:"},"ios":{"badge":"+1","alert":{"title":"美团外卖-t_abQZElFv #17 小店掌柜自动接单通知:","body":"您有一个美团外卖#17订单已经被小店掌柜自动接单啦！"},"sound":"true","extras":{"voice_num":3,"voice_code":"2_0102_131","voice_text":"美团外卖自动接单，刚刚为您接到新订单哦，请尽快处理"}}}}
  """;
  var data2 = """
  {
    "cid": "8103a4c628a0b98974ec1949-711261d4-5f17-4d2f-a855-5e5a8909b26e",
    "platform": "all",
    "audience": {"registration_id":["120c83f760fb60c6375"]},
    "notification": {
        "android": {
            "alert": "Hi, JPush!",
            "title": "Send to Android",
            "builder_id": 1,
            "large_icon": "http://www.jiguang.cn/largeIcon.jpg",
            "intent": {
                "url": "intent:#Intent;component=com.jiguang.push/com.example.jpushdemo.SettingActivity;end",
            },
            "extras": {
                "newsid": 321
            }
        },
        "ios": {
            "alert": "Hi, JPush!",
            "sound": "default",
            "badge": "+1",
            "thread-id": "default",
            "extras": {
                "newsid": 321
            }
        },
        "voip": {    // 此功能需要 JPush iOS SDK v3.3.2 及以上版本支持
            "key": "value" // 任意自定义key/value对，api透传下去
        },
        "quickapp": {
            "alert": "Hi, JPush!",
            "title": "Send to QuickApp",
            "page": "/page1"
        }
    },
    "message": {
        "msg_content": "Hi,JPush",
        "content_type": "text",
        "title": "msg",
        "extras": {
            "key": "value"
        }
    }
}
""";
  var data3 = """
{
    "platform":"all",
    "options":{
        "apns_production":true
    },
    "audience":{
        "registration_id":[
            "120c83f760fb60c6375",
            "1a0018970a7fb759133",
            "171976fa8a41394df14"
        ]
    },
    "notification":{
        "android":{
            "alert":"您有一个新的美团外卖#7订单已经被小店掌柜自动接单啦！",
            
            "extras":{
                "voice_num":3,
                "voice_code":"2_0102_131",
                "voice_text":"美团外卖自动接单，刚刚为您接到新订单哦，请尽快处理"
            },
            "channel_id":"jh_push",
            "title":"美团外卖-t_VinyU2wH #7 小店掌柜自动接单通知:"
        },
        "ios":{
            "badge":"+1",
            "alert":{
                "title":"美团外卖-t_VinyU2wH #7 小店掌柜自动接单通知:",
                "body":"您有一个美团外卖#7订单已经被小店掌柜自动接单啦！"
            },
            "sound":"true",
            "extras":{
                "voice_num":3,
                "voice_code":"2_0102_131",
                "voice_text":"美团外卖自动接单，刚刚为您接到新订单哦，请尽快处理"
            }
        }
    }
}
  """;
  var res = await http.post(Uri.parse('https://api.jpush.cn/v3/push'),
      headers: headers, body: data);
  if (res.statusCode != 200)
    throw Exception('http.post error: statusCode= ${res.body}');
  log('http.post error: statusCode= ${res.statusCode}');
  log('http.post error: statusCode= ${res.isRedirect}');
  print(res.body);
}
